/** 
 * Copyright (c) Krapht, 2011
 * 
 * "LogisticsPipes" is distributed under the terms of the Minecraft Mod Public 
 * License 1.0, or MMPL. Please check the contents of the license located in
 * http://www.mod-buildcraft.com/MMPL-1.0.txt
 */
package net.minecraft.src.buildcraft.krapht;

import java.util.LinkedList;

import net.minecraft.src.mod_LogisticsPipes;
import net.minecraft.src.buildcraft.api.EntityPassiveItem;
import net.minecraft.src.buildcraft.api.Orientations;
import net.minecraft.src.buildcraft.api.Position;
import net.minecraft.src.buildcraft.transport.IPipeTransportItemsHook;
import net.minecraft.src.buildcraft.transport.Pipe;
import net.minecraft.src.buildcraft.transport.PipeTransportItems;

public class PipeItemsLogistics extends Pipe implements IPipeTransportItemsHook {
	private static int pipecount = 0;
	
	public Router Router;
	
	private int _delayOffset = 0;
	
	public PipeItemsLogistics(int itemID) {
		super(new PipeTransportLogistics(), new PipeLogicLogistics(), itemID);
		((PipeTransportItems) transport).allowBouncing = true;
		this.Router = new Router(this);
		pipecount++;
		//Roughly spread pipe updates throughout the frequency, no need to maintain balance
		_delayOffset = pipecount % mod_LogisticsPipes.LOGISTICS_DETECTION_FREQUENCY; 
	}

	
	
	@Override
	public void updateEntity() {
		super.updateEntity();
		Router.update(worldObj.getWorldTime() % mod_LogisticsPipes.LOGISTICS_DETECTION_FREQUENCY == _delayOffset);
	}
	
	@Override
	public void destroy() {
		super.destroy();
		Router.destroy();
		//Just in case
		pipecount = Math.max(pipecount - 1, 0);
	}

	@Override
	public void entityEntered(EntityPassiveItem item, Orientations orientation) {
	}

	@Override
	public LinkedList<Orientations> filterPossibleMovements(
			LinkedList<Orientations> possibleOrientations, Position pos,
			EntityPassiveItem item) {
		return possibleOrientations;
	}

	@Override
	public int getBlockTexture() {
		return mod_LogisticsPipes.LOGISTICSPIPE_TEXTURE;
	}



	@Override
	public void readjustSpeed(EntityPassiveItem item) {
	}
}
